%if %{fedora} >= 23
%global jetty_version 8.1.17.v20150415
%else
%global jetty_version 8.1.14.v20131031
%endif
Name:           guacamole-client
Version:        0.9.8
Release:        3%{?dist}
Summary:        Server-side Java components that form the Guacamole application

License:        MPLv1.1 or GPL+ or AGPLv3+
URL:            http://guac-dev.org/
Source0:        http://downloads.sourceforge.net/guacamole/%{name}-%{version}.tar.gz
Source1:        %{name}-context.xml
BuildArch:      noarch

BuildRequires:  js-jquery1
BuildRequires:  maven-local
BuildRequires:  mvn(ch.qos.logback:logback-classic) >= 1.1.1
BuildRequires:  mvn(com.google.inject.extensions:guice-servlet) >= 3.0
%if 0%{?fedora} >= 23
BuildRequires:  mvn(com.sun.jersey.contribs:jersey-guice:1)
BuildRequires:  mvn(com.sun.jersey:jersey-server:1)
BuildRequires:  mvn(com.sun.jersey:jersey-json:1)
%else
BuildRequires:  mvn(com.sun.jersey.contribs:jersey-guice) >= 1.17.1
BuildRequires:  mvn(com.sun.jersey:jersey-server) >= 1.17.1
BuildRequires:  mvn(com.sun.jersey:jersey-json) >= 1.17.1
%endif
BuildRequires:  mvn(javax.annotation:jsr250-api)
BuildRequires:  mvn(javax.websocket:javax.websocket-api) >= 1.0
BuildRequires:  mvn(org.apache.maven.plugins:maven-clean-plugin)
BuildRequires:  mvn(org.apache.maven.plugins:maven-dependency-plugin)
BuildRequires:  mvn(org.apache.maven.plugins:maven-release-plugin)
BuildRequires:  mvn(org.apache.maven.plugins:maven-source-plugin)
BuildRequires:  mvn(org.apache.maven.plugins:maven-war-plugin)
BuildRequires:  mvn(org.eclipse.jetty:jetty-parent:pom:) >= 19
BuildRequires:  mvn(org.eclipse.jetty:jetty-websocket:%jetty_version)
BuildRequires:  mvn(org.slf4j:slf4j-jcl)

#BuildRequires:  mvn(org.apache.tomcat:tomcat-catalina) >= 7.0.37
#BuildRequires:  mvn(org.apache.tomcat:tomcat-coyote) >= 7.0.37
#BuildRequires:  mvn(org.eclipse.jetty.websocket:websocket-api)
#BuildRequires:  mvn(org.eclipse.jetty.websocket:websocket-servlet) >= 9.0.7

%description
Guacamole is an HTML5 remote desktop gateway.

Guacamole provides access to desktop environments using remote desktop protocols
like VNC and RDP. A centralized server acts as a tunnel and proxy, allowing
access to multiple desktops through a web browser.

No browser plugins are needed, and no client software needs to be installed. The
client requires nothing more than a web browser supporting HTML5 and AJAX.

The centralized server is provided by the "guacamole-server" package.

%package -n guacamole
Summary:        Web-based remote desktop application
Requires:       mvn(org.apache.commons:commons-logging)
Requires:       java-headless
Requires:       javapackages-tools
Requires:       mvn(log4j:log4j:12)
Requires:       mvn(org.slf4j:slf4j-api) >= 1.6.1
Requires:       mvn(org.slf4j:slf4j-jcl) >= 1.6.1
Requires:       tomcat
Requires:       tomcat-native
Requires:       js-jquery1

%description -n guacamole
This package contains the main HTML5 web application for the Guacamole stack
that provides access to desktop environments using remote desktop protocols such
as VNC or RDP.

A centralized server acts as a tunnel and proxy, allowing access to multiple
desktops through a web browser. No plugins are needed: the client requires
nothing more than a web browser supporting HTML5 and AJAX.

The centralized server is provided by the "guacd" package and its associated
"libguac-client-*" packages.

%package -n guacamole-javadoc
Summary:        API documentation for %{name}

%description -n guacamole-javadoc
This package contains the API documentation for %{name}.

%prep
%setup -q -n %{name}-%{version}
install -p -m644 -D %{SOURCE1} guacamole/src/main/webapp/META-INF/context.xml

%pom_disable_module extensions/guacamole-auth-jdbc
%pom_disable_module extensions/guacamole-auth-ldap
# Unavailable plugins
%pom_remove_plugin :minify-maven-plugin guacamole-common-js guacamole
%pom_remove_plugin com.keithbranton.mojo:angular-maven-plugin guacamole

# Disable Tomcat 7 support
%pom_remove_dep -r org.apache.tomcat:
rm -r guacamole/src/main/java/org/glyptodon/guacamole/net/basic/websocket/tomcat
sed -i '/tomcat.WebSocketTunnelModule/d' \
 guacamole/src/main/java/org/glyptodon/guacamole/net/basic/TunnelModule.java
# Disable Jetty 9 support
%pom_remove_dep -r org.eclipse.jetty.websocket:websocket-api
%pom_remove_dep -r org.eclipse.jetty.websocket:websocket-servlet
rm -r guacamole/src/main/java/org/glyptodon/guacamole/net/basic/websocket/jetty9
sed -i '/jetty9.WebSocketTunnelModule/d' \
 guacamole/src/main/java/org/glyptodon/guacamole/net/basic/TunnelModule.java
sed -i 's|jetty8.WebSocketTunnelModule",|jetty8.WebSocketTunnelModule"|' \
 guacamole/src/main/java/org/glyptodon/guacamole/net/basic/TunnelModule.java

# Remove bundle JavaScript libraries
rm -r guacamole/src/main/webapp/lib/angular* \
 guacamole/src/main/webapp/lib/blob \
 guacamole/src/main/webapp/lib/filesaver \
 guacamole/src/main/webapp/lib/lodash \
 guacamole/src/main/webapp/lib/messageformat

# Use pom_xpath_remove/inject?
%if 0%{?fedora} >= 23
sed -i -e 's/1.17.1/1.19/g' guacamole/pom.xml
sed -i -e "s/8.1.1.v20120215/%jetty_version/g" guacamole/pom.xml
%else
sed -i -e "s/8.1.1.v20120215/%jetty_version/g" guacamole/pom.xml
%endif

%build
# Skip automatic installation of war and tar.gz modules; XMvn doesn't support war installation yet (rhbz#963838)
%mvn_package "::{war,tar.gz}:" __noinstall
%mvn_build

%install
%mvn_install
# Put data files into tomcat's webapps directory
mkdir -p %{buildroot}%{_datadir}/tomcat/webapps/guacamole/
cp -frvp guacamole/target/guacamole-%{version}/* %{buildroot}%{_datadir}/tomcat/webapps/guacamole/

# Use Fedora packaged jar files
pushd %{buildroot}%{_datadir}/tomcat/webapps/guacamole/WEB-INF/lib/
xmvn-subst -s `ls *.jar | grep -v "guacamole"`
popd

# unbundle jquery, https://fedoraproject.org/wiki/Changes/jQuery
ln -fs %{_datadir}/javascript/jquery/1.11.2/jquery.min.js %{buildroot}%{_datadir}/tomcat/webapps/guacamole/lib/jquery/jquery.js


# Configuration file
mkdir -p %{buildroot}%{_sysconfdir}/guacamole
cp -p guacamole/doc/example/* %{buildroot}%{_sysconfdir}/guacamole
# No more available
#sed -i -e 's@/path/to@%%{_sysconfdir}/guacamole@g' %%{buildroot}%%{_sysconfdir}/guacamole/guacamole.properties
#ln -sf %%{_sysconfdir}/guacamole/guacamole.properties %%{buildroot}%%{_datadir}/tomcat/webapps/guacamole/WEB-INF/classes/

%files -n guacamole -f .mfiles
%license guacamole/LICENSE
%{_datadir}/tomcat/webapps/guacamole
%dir %{_sysconfdir}/guacamole
%config(noreplace) %attr(640,root,tomcat) %{_sysconfdir}/guacamole/user-mapping.xml
#%%config(noreplace) %%attr(640,root,tomcat) %%{_sysconfdir}/guacamole/guacamole.properties
%dir %{_javadir}/%{name}

%files -n guacamole-javadoc -f .mfiles-javadoc
%license guacamole/LICENSE

%changelog
* Tue Jun 21 2016 gil cattaneo <puntogil@libero.it> 0.9.8-3
- add missing build requires

* Wed Feb 03 2016 Fedora Release Engineering <releng@fedoraproject.org> - 0.9.8-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_24_Mass_Rebuild

* Fri Sep 11 2015 gil cattaneo <puntogil@libero.it> 0.9.8-1
- Update to 0.9.8.

* Tue Jul 14 2015 Simone Caronni <negativo17@gmail.com> - 0.9.6-3
- Update all build requirements for Fedora 23.

* Wed Jun 17 2015 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.9.6-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_23_Mass_Rebuild

* Thu Apr 30 2015 Simone Caronni <negativo17@gmail.com> - 0.9.6-1
- Update to 0.9.6.

* Tue Feb 24 2015 Simone Caronni <negativo17@gmail.com> - 0.9.5-1
- Update to 0.9.5.

* Fri Feb 13 2015 gil cattaneo <puntogil@libero.it> 0.9.4-2
- introduce license macro
- fix unowned directory

* Fri Jan 09 2015 Simone Caronni <negativo17@gmail.com> - 0.9.4-1
- Update to 0.9.4.

* Thu Jan 08 2015 Simone Caronni <negativo17@gmail.com> - 0.9.3-2
- Remove workaround for maven filtering.

* Mon Oct 06 2014 Simone Caronni <negativo17@gmail.com> - 0.9.3-1
- Update to 0.9.3.

* Wed Jul 23 2014 Simone Caronni <negativo17@gmail.com> - 0.9.2-1
- Update to 0.9.2.

* Mon Jul 21 2014 Simone Caronni <negativo17@gmail.com> - 0.9.1-3
- Update dependencies.

* Fri Jun 27 2014 Mikolaj Izdebski <mizdebsk@redhat.com> - 0.9.1-2
- Add workaround for MSHARED-325
- Resolves: rhbz#1106740

* Sat Jun 07 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.9.1-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_Mass_Rebuild

* Mon May 26 2014 Simone Caronni <negativo17@gmail.com> - 0.9.1-1
- Update to 0.9.1.
- Convert context.xml patch to additional file.

* Sun Apr 20 2014 Simone Caronni <negativo17@gmail.com> - 0.9.0-1
- Update to 0.9.0.
- Remove minify-maven-plugin. See
  https://bugzilla.redhat.com/show_bug.cgi?id=745515
- Use xmvn-subst for jar replacement.

* Wed Feb 26 2014 Simone Caronni <negativo17@gmail.com> - 0.8.3-5
- Remove symlink workaround, all Fedora/RHEL supported releases had 0.8.3 for
  quite some time.
- Switch to java-headless requirement (#1068116).

* Fri Oct 11 2013 Simone Caronni <negativo17@gmail.com> - 0.8.3-4
- Tighten permissions on user-mapping.xml.

* Mon Sep 23 2013 Simone Caronni <negativo17@gmail.com> - 0.8.3-3
- Rebuild with udpated source tarball.

* Tue Sep 10 2013 Simone Caronni <negativo17@gmail.com> - 0.8.3-2
- Change summary.

* Wed Aug 28 2013 Simone Caronni <negativo17@gmail.com> - 0.8.3-1
- Update to 0.8.3.
- Drop upstreamed patch.

* Mon Aug 26 2013 Simone Caronni <negativo17@gmail.com> - 0.8.2-4
- Rework spec file for recent Fedora 20 changes.
- Add proper Obsolete / Provides for javadoc packages.

* Sat Aug 03 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.8.2-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_20_Mass_Rebuild

* Mon Jul 22 2013 Simone Caronni <negativo17@gmail.com> - 0.8.2-2
- Review fixes.

* Tue Jul 16 2013 Simone Caronni <negativo17@gmail.com> - 0.8.2-1
- First build.
